## jove 4.17.4.4

=== Makefile ===
##########################################################################
# This program is Copyright (C) 1986-2002 by Jonathan Payne.  JOVE is    #
# provided by Jonathan and Jovehacks without charge and without          #
# warranty.  You may copy, modify, and/or distribute JOVE, provided that #
# this notice is included in all the source files and documentation.     #
##########################################################################

# SHELL for this Makefile (csh won't work!)
SHELL = /bin/sh

# If the system has no cmp, not a big deal, minor optimization to prevent
# a few needless rebuilds
CMP = cmp

# JOVEHOME is the directory in which pieces of JOVE are kept.  It is only used
#	in the default definitions of JSHAREDIR, JLIBDIR, JBINDIR, and JMANDIR.
# JSHAREDIR is for online documentation, and the distributed standard system-wide
# jove.rc file with some common
# JLIBDIR is for the PORTSRV and RECOVER programs.
# JBINDIR is where to put the executables JOVE and TEACHJOVE.
# XEXT is the extension for executables (empty for UNIX; .exe for CYGWIN)
# JMANDIR is where the manual pages go for JOVE, RECOVER and TEACHJOVE.
# MANEXT is the extension for the man pages, e.g., jove.1 or jove.l or jove.m.
#	Must not be "nr".
#
# If they don't exist, this makefile will try to create all *DIR directories
# (prefixed with $DESTDIR, as most packaging systems desire)
# All others must already exist.

JOVEHOME = /usr/local
JSHAREDIR = $(JOVEHOME)/share/jove
DSHAREDIR = $(DESTDIR)$(JSHAREDIR)
JLIBDIR = $(JOVEHOME)/lib/jove
DLIBDIR = $(DESTDIR)$(JLIBDIR)
JBINDIR = $(JOVEHOME)/bin
DBINDIR = $(DESTDIR)$(JBINDIR)
XEXT=
JMANDIR = $(JOVEHOME)/man/man$(MANEXT)
DMANDIR = $(DESTDIR)$(JMANDIR)
MANEXT = 1

# Install permission for SHAREDIR, LIBDIR, BINDIR
DPERM = 755
XPERM = 755

# JTMPDIR is where the tmp files get stored, usually /tmp, /var/tmp, or
# /usr/tmp.  If you wish to be able to recover buffers after a system
# crash, this needs to be a directory that isn't cleaned out on reboot.
# You would probably want to clean out that directory periodically with
# /etc/cron.
# JRECDIR is the directory in which RECOVER looks for JOVE's tempfiles
# (in case the system startup salvages tempfiles by moving them,
# which is probably a good idea).

JETCDIR = /etc/jove
DETCDIR = $(DESTDIR)$(JETCDIR)
JTMPDIR = /var/tmp
JRECDIR = /var/lib/jove/preserve
DRECDIR = $(DESTDIR)$(JRECDIR)

# Install permission for DRECDIR
RECPERM = 1777

# place to copy source tarball for rpmbuild
RPMHOME = $(HOME)/rpmbuild/SOURCES

# DFLTSHELL is the default shell invoked by JOVE and TEACHJOVE.
DFLTSHELL = /bin/sh

# The install commands of BSD and System V differ in unpleasant ways:
# -c: copy (BSD); -c dir: destination directory (SysV)
# -s: strip (BSD); -s: suppress messages (SysV)
# Also, the destination specification is very different.
# The result is that the System V install command must not be used.
# If you know that /bin/install is the BSD program, you can use it.
# "cp" will work reasonably well, but be aware that any links continue
# referencing the old file with new contents.

INSTALLFLAGS = # -g bin -o root

# XINSTALL to install executable files, prefer install since it is independent
# of user umask
# Linux/modern BSD/CYGWIN
XINSTALL=install $(INSTALLFLAGS) -m 755
TINSTALL=install $(INSTALLFLAGS) -m 444

# These should all just be right if the above ones are.
# You will confuse JOVE if you move anything from LIBDIR or SHAREDIR.

JOVE = $(DBINDIR)/jove$(XEXT)
TEACHJOVE = $(DBINDIR)/teachjove$(XEXT)
RECOVER = $(DLIBDIR)/recover$(XEXT)
PORTSRV = $(DLIBDIR)/portsrv$(XEXT)
JOVERC = $(DSHAREDIR)/jove.rc
TERMSDIR = $(DSHAREDIR)
CMDSDOC = $(DSHAREDIR)/cmds.doc
TEACHJOVEDOC = $(DSHAREDIR)/teach-jove
JOVEM = $(DMANDIR)/jove.$(MANEXT)
TEACHJOVEM = $(DMANDIR)/teachjove.$(MANEXT)
XJOVEM = $(DMANDIR)/xjove.$(MANEXT)
JOVETOOLM = $(DMANDIR)/jovetool.$(MANEXT)

# SYSDEFS: specify system characteristics to the C preprocessor using -D options
# The default (via buildflags.sh --cflags) is the system uname,
# which describes a number of modern systems.  If this isn't suitable for your system,
# or you want to customize it, then see README, sysdep.h, sysdep.doc.
# buildflags also sets a few other cflags (optimization, warnings)

SYSDEFS = `./buildflags.sh --cflags`

# Other compiler flags, flags passed to compiling and linking steps
# On most systems: -g for debugging, -O for optimization.
# -Os produces smaller binaries with gcc, should not hurt performance
OPTFLAGS = # -g -O -Wall -pedantic

# For making dependencies under BSD systems
DEPENDFLAG = -M
# or, using the official Sun ANSI C compiler
#	DEPENDFLAG = -xM

# Flags for Library to provide termcap and pty functions.
# Some modern open-source systems have dropped termcap, or ship it
# as part of the ncurses or tinfo packages.
# For systems without dynamic libraries, termcap or terminfo are smaller,
# and preferable to the bulkier curses library.
# Jove comes with a simplified termcap substitute that only supports
# ANSI X.3/VT[1-5]xx or compatible terminal emulators like xterm, rxvt, etc,
# which is almost certainly all that is necessary on modern machines.
# To use it, define -DJTC and leave TERMCAPLIB unset

TERMCAPLIB = `./buildflags.sh --libs`

# Extra libraries flags needed by various systems.
EXTRALIBS =

# Flags of linker (LDFLAGS)
# Most systems do not need any flags.
LDFLAGS =

CFLAGS = $(OPTFLAGS) $(SYSDEFS)

# LDCC can be used for link-time tools instead of CC
LDCC = $(CC)

# For cross compiling Jove, set CC to the cross compiler, and LOCALCC
# to the local C compiler. LOCALCC will be used for compiling setmaps,
# which is run as part of the compilation to generate the keymaps.
# Set LOCALCFLAGS and LOCALLDFLAGS to anything extra (other than SYSDEFS,
# which is set automatically), though no optimization or debug or special
# flags are usually needed (other than Xenix?!), since setmaps is 
# run just once, so use whatever compiles fastest.

LOCALCC = $(CC)
LOCALCFLAGS =
LOCALLDFLAGS = $(LDFLAGS)
LOCALEXTRALIBS = 
LOCALEXT = 

# Objects are grouped into overlays for the benefit of (at least) 2.xBSD.

BASESEG = commands.o keys.o argcount.o ask.o buf.o jctype.o delete.o \
	  disp.o insert.o io.o jove.o marks.o misc.o re.o \
	  screen.o termcap.o unix.o util.o vars.o list.o keymaps.o \
	  mouse.o jtc.o
OVLAY1 = abbrev.o rec.o para.o fmt.o
OVLAY2 = c.o wind.o fp.o move.o
OVLAY3 = extend.o macros.o
OVLAY4 = iproc.o reapp.o
OVLAY5 = proc.o scandir.o term.o case.o

OBJECTS = $(BASESEG) $(OVLAY1) $(OVLAY2) $(OVLAY3) $(OVLAY4) $(OVLAY5)

# win32.o when cross-compiling with mingw for Win32
EXTRAOBJS =
WINDRES = i686-w64-mingw32-windres

ZIP=zip
ZIPEXT=zip
ZIPOPTS=-q -k	# common options for both binary and code files
ZIPTXTOPT=-l -r	# options for recursively adding code files
TAR=tar
BACKUPDEV=/dev/rst8	# for tape-backup target!

# These NROFF, TROFF and TROFFPOST settings work with groff.
# Classic Unix and derivatives used to have ditroff, for which use:
#	NROFF = nroff
#	TROFF = troff
#	TROFFPOST = | /usr/lib/lp/postscript/dpost -
NROFF = nroff -Tascii
TROFF = troff
TROFFPOST = 

MANUALS = $(JOVEM) $(TEACHJOVEM)

C_SRC = commands.c commands.tab abbrev.c argcount.c ask.c buf.c c.c case.c jctype.c \
	delete.c disp.c extend.c fp.c fmt.c insert.c io.c iproc.c \
	jove.c jtc.c list.c macros.c marks.c misc.c move.c para.c \
	proc.c re.c reapp.c rec.c scandir.c screen.c term.c termcap.c unix.c \
	util.c vars.c vars.tab wind.c msgetch.c mac.c keymaps.c ibmpcdos.c \
	mouse.c win32.c

SOURCES = $(C_SRC) portsrv.c recover.c setmaps.c teachjove.c

HEADERS = abbrev.h argcount.h ask.h buf.h c.h case.h chars.h commands.h \
	jctype.h dataobj.h delete.h disp.h extend.h externs.h \
	fmt.h fp.h insert.h io.h iproc.h jove.h \
	keymaps.h list.h mac.h macros.h marks.h \
	misc.h mouse.h move.h para.h proc.h \
	re.h reapp.h rec.h recover.h scandir.h screen.h \
	select.h sysdep.h sysprocs.h temp.h term.h ttystate.h \
	tune.h util.h vars.h version.h wind.h

DOCTERMS =	doc/jove.rc.sun doc/keychart.sun \
	doc/jove.rc.sun-cmd doc/keychart.sun-cmd \
	doc/jove.rc.vt100 doc/keychart.vt100 \
	doc/jove.rc.wyse doc/keychart.wyse \
	doc/jove.rc.xterm doc/keychart.xterm \
	doc/jove.rc.xterm-256color doc/keychart.xterm-256color \
	doc/jove.rc.z29 doc/keychart.z29 \
	doc/jove.rc.3022 doc/keychart.3022 \
	doc/keychart. \
	doc/XTermresource

CDOC = doc/cmds.doc

# formatted docs, we ship these in the distrib to avoid groff dependency
# and for non-Unix/Linux platforms.  NOTE: These will be removed by clobber.
# Also note that jove.man and jove.man.ps require the ms macros
# (tmac.s or s.tmac) which many systems do not install with base groff.
FDOCS = $(CDOC) doc/jove.man doc/jove.man.ps doc/jove.doc

# files we generate that we also ship in distrib for platforms sans sed
# NOTE: these will be removed by clobber.
GEN = 	jove.spec doc/jove.rc doc/jove.$(MANEXT) \
	doc/teachjove.$(MANEXT) doc/jovetool.$(MANEXT)

DOCS =	doc/README doc/teach-jove doc/jove.qref \
	doc/intro.nr doc/cmds.macros.nr doc/cmds.nr doc/contents.nr \
	doc/jove.nr doc/teachjove.nr doc/xjove.nr doc/jovetool.nr \
	doc/jove.rc.in doc/example.rc $(DOCTERMS) $(FDOCS) $(GEN)

MISC =	Makefile Makefile.msc Makefile.wat \
	README README.dos README.win ChangeLog LICENSE \
	sysdep.doc tune.doc style.doc jspec.in buildflags.sh

SUPPORT = teachjove.c recover.c setmaps.c portsrv.c keys.txt \
	menumaps.txt mjovers.Hqx jjove.ico jjove.rc

BACKUPS = $(HEADERS) $(C_SRC) $(SUPPORT) $(MISC)

# all: default target.
# Builds everything that "install" needs.
all:	jjove$(XEXT) recover$(XEXT) teachjove$(XEXT) portsrv$(XEXT) $(CDOC) $(GEN)

jjove$(XEXT):	$(OBJECTS) $(EXTRAOBJS)
	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o jjove$(XEXT) $(OBJECTS) $(EXTRAOBJS) $(EXTRALIBS) $(TERMCAPLIB)
	@-size jjove$(XEXT)
	@-echo compiled with $(CC) $(CFLAGS)
	@-echo linked $(XEXT) with $(LDCC) $(LDFLAGS) $(OPTFLAGS) $(EXTRAOBJS) $(EXTRALIBS) $(TERMCAPLIB)

# For mingw icon
jjove.coff: jjove.rc version.h
	$(WINDRES) -r jjove.rc -fo jjove.coff

# For 2.xBSD: link jove as a set of overlays.  Not tested recently.

ovjove:	$(OBJECTS)
	ld $(LDFLAGS) $(OPTFLAGS) -X /lib/crt0.o \
		-Z $(OVLAY1) \
		-Z $(OVLAY2) \
		-Z $(OVLAY3) \
		-Z $(OVLAY4) \
		-Z $(OVLAY5) \
		-Y $(BASESEG) \
		-o jjove$(XEXT) $(EXTRALIBS) $(TERMCAPLIB) -lc
	@-size jjove$(XEXT)

# portsrv is only needed if IPROCS are implemented using PIPEPROCS
# (modern systems use PTYPROCS).
# Making PORTSRVINST null suppresses installing portsrv.

# PORTSRVINST=$(PORTSRV)
PORTSRVINST=

portsrv$(XEXT):	portsrv.o
	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o portsrv$(XEXT) portsrv.o $(EXTRALIBS)

recover$(XEXT):	recover.o
	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o recover$(XEXT) recover.o $(EXTRALIBS)

teachjove$(XEXT):	teachjove.o
	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o teachjove$(XEXT) teachjove.o $(EXTRALIBS)

# don't optimize setmaps.c because it produces bad code in some places
# for some reason

setmaps$(LOCALEXT):	setmaps.o
	$(LOCALCC) $(LOCALLDFLAGS) -o setmaps$(LOCALEXT) setmaps.o $(LOCALEXTRALIBS)

setmaps.o:	setmaps.c
	$(LOCALCC) $(LOCALCFLAGS) $(SYSDEFS) -c setmaps.c

keys.c:	setmaps$(LOCALEXT) keys.txt
	@-rm -f keys.c
	./setmaps$(LOCALEXT) < keys.txt > keys.tmp && \
	if ! $(CMP) -s keys.c keys.tmp 2> /dev/null; then mv keys.tmp keys.c; else rm keys.tmp; fi

keys.o:	keys.c tune.h sysdep.h jove.h keymaps.h dataobj.h commands.h

.ALWAYS:

# BSD sed cannot handle \t, and having tabs in the whitespace feels fragile.
.version: .ALWAYS
	@-rm -f version.h.tmp
	@sed -n 's/# *define  *jversion  *"\([0-9\\.]*\)".*/\1/p' version.h > .version.tmp; \
	if ! $(CMP) -s .version.tmp .version 2> /dev/null; then mv .version.tmp .version; else rm .version.tmp; fi

jove.spec: .version .ALWAYS
	@-rm -f jspec.tmp
	@v=`sed 's/_.*//' .version`; sed "s,__VERSION__,$$v,g" jspec.in > jspec.tmp; \
	if ! $(CMP) -s jove.spec jspec.tmp 2> /dev/null; then mv jspec.tmp jove.spec; else rm jspec.tmp; fi

paths.h: .ALWAYS
	@-rm -f paths.tmp

=== debian/changelog ===
jove (4.17.4.4-1) unstable; urgency=low

  * New upstream release.
  * added fdocs-target which was removed from default upstream.

 -- Cord Beermann <cord@debian.org>  Sat, 11 Jun 2022 14:28:18 +0200

jove (4.17.4.3-1) unstable; urgency=low

  * New upstream release.
    + should now build on Hurd
  * cleaned changelog from a double entry out of order.

 -- Cord Beermann <cord@debian.org>  Fri, 10 Jun 2022 21:09:41 +0200

jove (4.17.4.1-1) unstable; urgency=low

  * New upstream release.
  * dropping pkg-config as Build Dependency
  * removed SYSDEFS-Definition from build process

 -- Cord Beermann <cord@debian.org>  Mon, 30 May 2022 16:51:56 +0200

=== debian/control ===
Source: jove
Section: editors
Priority: optional
Maintainer: Cord Beermann <cord@debian.org>
Build-Depends: debhelper-compat (= 13), po-debconf, libncurses-dev, groff
Standards-Version: 4.6.1
Homepage: https://github.com/jonmacs/jove
Rules-Requires-Root: no

Package: jove
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: editor
Suggests: aspell, ctags | emacs-bin-common
Description: Jonathan's Own Version of Emacs - a compact, powerful editor
 Jove is a compact, powerful Emacs-style text-editor. It provides the common
 emacs keyboard bindings, together with a reasonable assortment of the most
 popular advanced features (e.g. interactive shell windows, compile-it,
 language specific modes) while weighing in with CPU, memory, and disk
 requirements comparable to vi(1).

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7)
# (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk
CC_FOR_BUILD ?= cc

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- \
		OPTFLAGS="$(CFLAGS) $(CPPFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		JOVEHOME=/usr \
		JMANDIR=/usr/share/man/man1 \
		LOCALCC=$(CC_FOR_BUILD) fdocs

override_dh_auto_install:
	dh_auto_install -- JOVEHOME=/usr JMANDIR=/usr/share/man/man1
	cp debian/jem.rc debian/jem1.txt debian/jem1.hlp debian/jove/usr/share/jove
	cp debian/jove.rc debian/jove/etc/jove/jove.rc

override_dh_clean:
	dh_clean
	debconf-updatepo

## jove 4.17.4.7

=== debian/changelog ===
jove (4.17.4.7-1) unstable; urgency=low

  * New upstream release.
    + switched from plain make to jmake.sh wrapper with pkgconf and 
      dropped compilerflags from debian/rules
  * includes compiler hardening
  * includes correct debugsym
  * fix FTCBFS: Do not build jove during dh_auto_install without
    cross tools (closes: 1023583)
    thanks to Helmut Grohne <helmut@subdivi.de>
  * make Lintian happy again.
    (better documentation about change of syntax would have been nice.)

 -- Cord Beermann <cord@debian.org>  Sat, 10 Dec 2022 22:15:35 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: editors
 Priority: optional
 Maintainer: Cord Beermann <cord@debian.org>
-Build-Depends: debhelper-compat (= 13), po-debconf, libncurses-dev, groff
+Build-Depends: debhelper-compat (= 13), po-debconf, libncurses-dev, groff, pkgconf
 Standards-Version: 4.6.1
 Homepage: https://github.com/jonmacs/jove
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -8,21 +8,24 @@
 export DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/buildtools.mk
+
 CC_FOR_BUILD ?= cc
 
 %:
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- \
-		OPTFLAGS="$(CFLAGS) $(CPPFLAGS)" \
-		LDFLAGS="$(LDFLAGS)" \
+	./jmake.sh \
 		JOVEHOME=/usr \
 		JMANDIR=/usr/share/man/man1 \
-		LOCALCC=$(CC_FOR_BUILD) fdocs
+		LOCALCC=$(CC_FOR_BUILD) fdocs all
 
 override_dh_auto_install:
-	dh_auto_install -- JOVEHOME=/usr JMANDIR=/usr/share/man/man1
+	./jmake.sh \
+		DESTDIR=debian/jove \
+		JOVEHOME=/usr \
+		JMANDIR=/usr/share/man/man1 \
+		install
 	cp debian/jem.rc debian/jem1.txt debian/jem1.hlp debian/jove/usr/share/jove
 	cp debian/jove.rc debian/jove/etc/jove/jove.rc

## jove 4.17.4.8

=== debian/changelog ===
jove (4.17.4.8-1) unstable; urgency=low

  * New upstream release.
  * Revert back to dh_auto_build

 -- Cord Beermann <cord@debian.org>  Sat, 17 Dec 2022 11:04:50 +0100

## jove 4.17.4.9

=== Makefile ===
--- 
+++ 
@@ -100,25 +100,38 @@
 XJOVEM = $(DMANDIR)/xjove.$(MANEXT)
 JOVETOOLM = $(DMANDIR)/jovetool.$(MANEXT)
 
+# We set CFLAGS to SYSDEFS and OPTFLAGS, so we can set
+# the definitions in SYSDEFS (needed for the local compiler
+# of keys.c, and the target compiler for the rest, in order
+# to make this work for cross-compilation)
+
 # SYSDEFS: specify system characteristics to the C preprocessor using -D options
-# The default (via buildflags.sh --cflags) is the system uname,
-# which describes a number of modern systems.  If this isn't suitable for your system,
-# or you want to customize it, then see README, sysdep.h, sysdep.doc.
-# buildflags also sets a few other cflags (optimization, warnings)
-
-SYSDEFS = `./buildflags.sh --cflags`
-
-# Other compiler flags, flags passed to compiling and linking steps
-# On most systems: -g for debugging, -O for optimization.
-# -Os produces smaller binaries with gcc, should not hurt performance
-OPTFLAGS = # -g -O -Wall -pedantic
+# The default is the system uname, which should work for many
+# popular modern systems like Linux, *BSD, OpenIndiana.
+# If sysdep.h does not define a block for your system, or uname produces
+# an illegal symbol on your platform (Cygwin, GNU Hurd), use jmake
+# or see README, sysdep.h, sysdep.doc.
+# XXX Among modern systems, FreeBSD does not put CPPFLAGS in the default
+# .c.o make build rules, so we put it in SYSDEFS, which we then add
+# to CFLAGS.  This means the contents of CPPFLAGS will likely 
+# appear twice in cc invocations on non-FreeBSD (i.e. OpenBSD, NetBSD, Linux)
+# so best to avoid setting it (the default value is empty anyway)
+SYSDEFS = -D`uname` -DJTC $(CPPFLAGS)
+
+# OPTFLAGS: compiler flags that are passed to both the compiling & linking steps
+# e.g. -g for debugging, -O for optimization.
+OPTFLAGS = -O
+
+# CFLAGS (i.e compile flags for the target compiler) are OPTFLAGS and SYSDEFS,
+# DO NOT OVERRIDE
+CFLAGS = $(OPTFLAGS) $(SYSDEFS)
 
 # For making dependencies under BSD systems
 DEPENDFLAG = -M
 # or, using the official Sun ANSI C compiler
 #	DEPENDFLAG = -xM
 
-# Flags for Library to provide termcap and pty functions.
+# Flags for Libraries to provide termcap and pty functions.
 # Some modern open-source systems have dropped termcap, or ship it
 # as part of the ncurses or tinfo packages.
 # For systems without dynamic libraries, termcap or terminfo are smaller,
@@ -128,33 +141,31 @@
 # which is almost certainly all that is necessary on modern machines.
 # To use it, define -DJTC and leave TERMCAPLIB unset
 
-TERMCAPLIB = `./buildflags.sh --libs`
-
-# Extra libraries flags needed by various systems.
-EXTRALIBS =
-
-# Flags of linker (LDFLAGS)
-# Most systems do not need any flags.
-LDFLAGS =
-
-CFLAGS = $(OPTFLAGS) $(SYSDEFS)
-
-# LDCC can be used for link-time tools instead of CC
+TERMCAPLIB = # for compatibility with old packagers, deprecated, use LDLIBS
+EXTRALIBS = -lutil # for compatibility with old packagers, deprecated, use LDLIBS
+LDLIBS = $(TERMCAPLIB) $(EXTRALIBS)
+
+# linker flags (LDFLAGS) not needed for most systems
+LDFLAGS = 
+
+# LDCC can be used for link-time alternatives to CC.  Also useful
+# for purify or similar link-time processing.
 LDCC = $(CC)
 
 # For cross compiling Jove, set CC to the cross compiler, and LOCALCC
 # to the local C compiler. LOCALCC will be used for compiling setmaps,
 # which is run as part of the compilation to generate the keymaps.
 # Set LOCALCFLAGS and LOCALLDFLAGS to anything extra (other than SYSDEFS,
-# which is set automatically), though no optimization or debug or special
+# which must be the same for local and cross, so that setmaps generates
+# the correct key bindings), though no optimization or debug or special
 # flags are usually needed (other than Xenix?!), since setmaps is 
 # run just once, so use whatever compiles fastest.
 
 LOCALCC = $(CC)
-LOCALCFLAGS =
+LOCALCFLAGS = # nothing really needed for setmaps
 LOCALLDFLAGS = $(LDFLAGS)
-LOCALEXTRALIBS = 
-LOCALEXT = 
+LOCALEXTRALIBS = # nothing really needed for setmaps
+LOCALEXT = # default is a Un*x-style machine, not Windows
 
 # Objects are grouped into overlays for the benefit of (at least) 2.xBSD.
 
@@ -241,7 +252,7 @@
 
 MISC =	Makefile Makefile.msc Makefile.wat \
 	README README.dos README.win ChangeLog LICENSE \
-	sysdep.doc tune.doc style.doc jspec.in buildflags.sh
+	sysdep.doc tune.doc style.doc jspec.in jmake.sh
 
 SUPPORT = teachjove.c recover.c setmaps.c portsrv.c keys.txt \
 	menumaps.txt mjovers.Hqx jjove.ico jjove.rc
@@ -253,10 +264,8 @@
 all:	jjove$(XEXT) recover$(XEXT) teachjove$(XEXT) portsrv$(XEXT) $(CDOC) $(GEN)
 
 jjove$(XEXT):	$(OBJECTS) $(EXTRAOBJS)
-	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o jjove$(XEXT) $(OBJECTS) $(EXTRAOBJS) $(EXTRALIBS) $(TERMCAPLIB)
+	$(LDCC) $(LDFLAGS) $(CFLAGS) -o jjove$(XEXT) $(OBJECTS) $(EXTRAOBJS) $(LDLIBS)
 	@-size jjove$(XEXT)
-	@-echo compiled with $(CC) $(CFLAGS)
-	@-echo linked $(XEXT) with $(LDCC) $(LDFLAGS) $(OPTFLAGS) $(EXTRAOBJS) $(EXTRALIBS) $(TERMCAPLIB)
 
 # For mingw icon
 jjove.coff: jjove.rc version.h
@@ -283,42 +292,21 @@
 PORTSRVINST=
 
 portsrv$(XEXT):	portsrv.o
-	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o portsrv$(XEXT) portsrv.o $(EXTRALIBS)
+	$(LDCC) $(LDFLAGS) $(CFLAGS) -o portsrv$(XEXT) portsrv.o $(LDLIBS)
 
 recover$(XEXT):	recover.o
-	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o recover$(XEXT) recover.o $(EXTRALIBS)
+	$(LDCC) $(LDFLAGS) $(CFLAGS) -o recover$(XEXT) recover.o $(LDLIBS)
 
 teachjove$(XEXT):	teachjove.o
-	$(LDCC) $(LDFLAGS) $(OPTFLAGS) -o teachjove$(XEXT) teachjove.o $(EXTRALIBS)
-
-# don't optimize setmaps.c because it produces bad code in some places
-# for some reason
-
+	$(LDCC) $(LDFLAGS) $(CFLAGS) -o teachjove$(XEXT) teachjove.o $(LDLIBS)
+
+# no need to optimize setmaps since it is run once during build, so faster
+# compile is better than faster executable (also urban legend that 
+# optimization produced bad code for setmaps!)
 setmaps$(LOCALEXT):	setmaps.o
-	$(LOCALCC) $(LOCALLDFLAGS) -o setmaps$(LOCALEXT) setmaps.o $(LOCALEXTRALIBS)
-
+	$(LOCALCC) $(LOCALLDFLAGS) $(LOCALCFLAGS)-o setmaps$(LOCALEXT) setmaps.o $(LOCALEXTRALIBS)
+
+# Critical that setmaps be compiled with same SYSDEFS
 setmaps.o:	setmaps.c
 	$(LOCALCC) $(LOCALCFLAGS) $(SYSDEFS) -c setmaps.c
 
-keys.c:	setmaps$(LOCALEXT) keys.txt
-	@-rm -f keys.c
-	./setmaps$(LOCALEXT) < keys.txt > keys.tmp && \
-	if ! $(CMP) -s keys.c keys.tmp 2> /dev/null; then mv keys.tmp keys.c; else rm keys.tmp; fi
-
-keys.o:	keys.c tune.h sysdep.h jove.h keymaps.h dataobj.h commands.h
-
-.ALWAYS:
-
-# BSD sed cannot handle \t, and having tabs in the whitespace feels fragile.
-.version: .ALWAYS
-	@-rm -f version.h.tmp
-	@sed -n 's/# *define  *jversion  *"\([0-9\\.]*\)".*/\1/p' version.h > .version.tmp; \
-	if ! $(CMP) -s .version.tmp .version 2> /dev/null; then mv .version.tmp .version; else rm .version.tmp; fi
-
-jove.spec: .version .ALWAYS
-	@-rm -f jspec.tmp
-	@v=`sed 's/_.*//' .version`; sed "s,__VERSION__,$$v,g" jspec.in > jspec.tmp; \
-	if ! $(CMP) -s jove.spec jspec.tmp 2> /dev/null; then mv jspec.tmp jove.spec; else rm jspec.tmp; fi
-
-paths.h: .ALWAYS
-	@-rm -f paths.tmp

=== debian/changelog ===
jove (4.17.4.9-1) unstable; urgency=low

  * New upstream release.

 -- Cord Beermann <cord@debian.org>  Sun, 18 Dec 2022 13:11:45 +0100

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7)
# (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk
CPPFLAGS+=$(shell $(PKG_CONFIG) --cflags ncurses)
LDLIBS+=$(shell $(PKG_CONFIG) --libs ncurses)

CC_FOR_BUILD ?= cc

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- \
		SYSDEFS="-DLinux" \
		OPTFLAGS="$(CFLAGS)" \
		LDLIBS="$(LDLIBS)" \
		LDFLAGS="$(LDFLAGS)" \
		JOVEHOME=/usr \
		JMANDIR=/usr/share/man/man1 \
		LOCALCC=$(CC_FOR_BUILD) \
		fdocs all

override_dh_auto_install:
	dh_auto_install -- \
		JOVEHOME=/usr \
		JMANDIR=/usr/share/man/man1
	cp debian/jem.rc debian/jem1.txt debian/jem1.hlp debian/jove/usr/share/jove
	cp debian/jove.rc debian/jove/etc/jove/jove.rc

override_dh_clean:
	dh_clean
	debconf-updatepo

## jove 4.17.5.1

=== Makefile ===
--- 
+++ 
@@ -22,12 +22,19 @@
 # JMANDIR is where the manual pages go for JOVE, RECOVER and TEACHJOVE.
 # MANEXT is the extension for the man pages, e.g., jove.1 or jove.l or jove.m.
 #	Must not be "nr".
+# JTEACHBASE is the basename of the installed teach-jove tutorial file,
+# which will be teachjov.txt on MSFILESYSTEM (and the zip file),
+# but teach-jove on Unix/Linux installs.
 #
 # If they don't exist, this makefile will try to create all *DIR directories
-# (prefixed with $DESTDIR, as most packaging systems desire)
-# All others must already exist.
+# (prefixed with $DESTDIR, as most packaging systems desire; DESTDIR must
+# end with a slash) All others must already exist.
+#
+# Hack for relocatable installs: set JSHAREDIR and JLIBDIR and JBINDIR to relative 
+# paths, and set DESTDIR to an empty directory.
 
 JOVEHOME = /usr/local
+JREL =
 JSHAREDIR = $(JOVEHOME)/share/jove
 DSHAREDIR = $(DESTDIR)$(JSHAREDIR)
 JLIBDIR = $(JOVEHOME)/lib/jove
@@ -38,6 +45,7 @@
 JMANDIR = $(JOVEHOME)/man/man$(MANEXT)
 DMANDIR = $(DESTDIR)$(JMANDIR)
 MANEXT = 1
+JTEACHBASE = teach-jove
 
 # Install permission for SHAREDIR, LIBDIR, BINDIR
 DPERM = 755
@@ -64,7 +72,7 @@
 # place to copy source tarball for rpmbuild
 RPMHOME = $(HOME)/rpmbuild/SOURCES
 
-# DFLTSHELL is the default shell invoked by JOVE and TEACHJOVE.
+# DFLTSHELL is the default shell invoked by JOVE.
 DFLTSHELL = /bin/sh
 
 # The install commands of BSD and System V differ in unpleasant ways:
@@ -88,13 +96,12 @@
 # You will confuse JOVE if you move anything from LIBDIR or SHAREDIR.
 
 JOVE = $(DBINDIR)/jove$(XEXT)
-TEACHJOVE = $(DBINDIR)/teachjove$(XEXT)
+TEACHJOVE = $(DBINDIR)/teachjove
 RECOVER = $(DLIBDIR)/recover$(XEXT)
 PORTSRV = $(DLIBDIR)/portsrv$(XEXT)
 JOVERC = $(DSHAREDIR)/jove.rc
 TERMSDIR = $(DSHAREDIR)
-CMDSDOC = $(DSHAREDIR)/cmds.doc
-TEACHJOVEDOC = $(DSHAREDIR)/teach-jove
+CMDSDOC = $(DSHAREDIR)/cmds.txt
 JOVEM = $(DMANDIR)/jove.$(MANEXT)
 TEACHJOVEM = $(DMANDIR)/teachjove.$(MANEXT)
 XJOVEM = $(DMANDIR)/xjove.$(MANEXT)
@@ -110,7 +117,7 @@
 # popular modern systems like Linux, *BSD, OpenIndiana.
 # If sysdep.h does not define a block for your system, or uname produces
 # an illegal symbol on your platform (Cygwin, GNU Hurd), use jmake
-# or see README, sysdep.h, sysdep.doc.
+# or see README, sysdep.h, sysdep.txt.
 # XXX Among modern systems, FreeBSD does not put CPPFLAGS in the default
 # .c.o make build rules, so we put it in SYSDEFS, which we then add
 # to CFLAGS.  This means the contents of CPPFLAGS will likely 
@@ -183,7 +190,9 @@
 
 # win32.o when cross-compiling with mingw for Win32
 EXTRAOBJS =
-WINDRES = i686-w64-mingw32-windres
+# jjove.coff for cross-compiling with mingw for Win32
+ICON = 
+WINDRES = windres # probably needs i686-w64-mingw32- prefix or similar
 
 ZIP=zip
 ZIPEXT=zip
@@ -197,9 +206,10 @@
 #	NROFF = nroff
 #	TROFF = troff
 #	TROFFPOST = | /usr/lib/lp/postscript/dpost -
-NROFF = nroff -Tascii
+NROFF = nroff
 TROFF = troff
-TROFFPOST = 
+TROFFPOST = |grops
+TROFFPDF = |gropdf
 
 MANUALS = $(JOVEM) $(TEACHJOVEM)
 
@@ -210,7 +220,7 @@
 	util.c vars.c vars.tab wind.c msgetch.c mac.c keymaps.c ibmpcdos.c \
 	mouse.c win32.c
 
-SOURCES = $(C_SRC) portsrv.c recover.c setmaps.c teachjove.c
+SOURCES = $(C_SRC) portsrv.c recover.c setmaps.c
 
 HEADERS = abbrev.h argcount.h ask.h buf.h c.h case.h chars.h commands.h \
 	jctype.h dataobj.h delete.h disp.h extend.h externs.h \
@@ -229,42 +239,46 @@
 	doc/jove.rc.xterm-256color doc/keychart.xterm-256color \
 	doc/jove.rc.z29 doc/keychart.z29 \
 	doc/jove.rc.3022 doc/keychart.3022 \
-	doc/keychart. \
 	doc/XTermresource
 
-CDOC = doc/cmds.doc
+# XDOCS require no formatting
+XDOCS = doc/teach-jove doc/jove.qref
 
 # formatted docs, we ship these in the distrib to avoid groff dependency
 # and for non-Unix/Linux platforms.  NOTE: These will be removed by clobber.
-# Also note that jove.man and jove.man.ps require the ms macros
+# Also note that jove.man.* require the ms macros
 # (tmac.s or s.tmac) which many systems do not install with base groff.
-FDOCS = $(CDOC) doc/jove.man doc/jove.man.ps doc/jove.doc
+# Now prefer doc/jove.man.pdf to doc/jove.man.ps (more universal)
+FDOCS = doc/cmds.txt doc/jove.man.txt doc/jove.man.pdf
 
 # files we generate that we also ship in distrib for platforms sans sed
 # NOTE: these will be removed by clobber.
-GEN = 	jove.spec doc/jove.rc doc/jove.$(MANEXT) \
+GEN = 	doc/jove.rc doc/jove.$(MANEXT) \
 	doc/teachjove.$(MANEXT) doc/jovetool.$(MANEXT)
 
-DOCS =	doc/README doc/teach-jove doc/jove.qref \
-	doc/intro.nr doc/cmds.macros.nr doc/cmds.nr doc/contents.nr \
+DOSDOCS =  doc/README doc/teach-jove doc/jove.qref doc/example.rc doc/jem.txt \
+	doc/jove.txt
+
+DOCS =  doc/intro.nr doc/cmds.macros.nr doc/cmds.nr doc/contents.nr \
 	doc/jove.nr doc/teachjove.nr doc/xjove.nr doc/jovetool.nr \
-	doc/jove.rc.in doc/example.rc $(DOCTERMS) $(FDOCS) $(GEN)
+	doc/jove.rc.in $(DOSDOCS) $(DOCTERMS) $(FDOCS) $(GEN)
 
 MISC =	Makefile Makefile.msc Makefile.wat \
 	README README.dos README.win ChangeLog LICENSE \
-	sysdep.doc tune.doc style.doc jspec.in jmake.sh
-
-SUPPORT = teachjove.c recover.c setmaps.c portsrv.c keys.txt \
-	menumaps.txt mjovers.Hqx jjove.ico jjove.rc
+	sysdep.txt tune.txt style.txt jmake.sh \
+	testbuild.sh testmailer.sh
+
+SUPPORT = recover.c setmaps.c portsrv.c keys.txt \
+	menumaps.txt mjovers.Hqx jjove.ico jjove.rc teachjove
 
 BACKUPS = $(HEADERS) $(C_SRC) $(SUPPORT) $(MISC)
 
 # all: default target.
 # Builds everything that "install" needs.
-all:	jjove$(XEXT) recover$(XEXT) teachjove$(XEXT) portsrv$(XEXT) $(CDOC) $(GEN)
-
-jjove$(XEXT):	$(OBJECTS) $(EXTRAOBJS)
-	$(LDCC) $(LDFLAGS) $(CFLAGS) -o jjove$(XEXT) $(OBJECTS) $(EXTRAOBJS) $(LDLIBS)
+all:	jjove$(XEXT) recover$(XEXT) portsrv$(XEXT) $(FDOCS) $(GEN)
+
+jjove$(XEXT):	$(OBJECTS) $(EXTRAOBJS) $(ICON)
+	$(LDCC) $(LDFLAGS) $(CFLAGS) -o jjove$(XEXT) $(OBJECTS) $(EXTRAOBJS) $(ICON) $(LDLIBS)
 	@-size jjove$(XEXT)
 
 # For mingw icon
@@ -295,18 +309,3 @@
 	$(LDCC) $(LDFLAGS) $(CFLAGS) -o portsrv$(XEXT) portsrv.o $(LDLIBS)
 
 recover$(XEXT):	recover.o
-	$(LDCC) $(LDFLAGS) $(CFLAGS) -o recover$(XEXT) recover.o $(LDLIBS)
-
-teachjove$(XEXT):	teachjove.o
-	$(LDCC) $(LDFLAGS) $(CFLAGS) -o teachjove$(XEXT) teachjove.o $(LDLIBS)
-
-# no need to optimize setmaps since it is run once during build, so faster
-# compile is better than faster executable (also urban legend that 
-# optimization produced bad code for setmaps!)
-setmaps$(LOCALEXT):	setmaps.o
-	$(LOCALCC) $(LOCALLDFLAGS) $(LOCALCFLAGS)-o setmaps$(LOCALEXT) setmaps.o $(LOCALEXTRALIBS)
-
-# Critical that setmaps be compiled with same SYSDEFS
-setmaps.o:	setmaps.c
-	$(LOCALCC) $(LOCALCFLAGS) $(SYSDEFS) -c setmaps.c
-

=== debian/changelog ===
jove (4.17.5.1-2) unstable; urgency=medium

  * removed duplicate documentation files

 -- Cord Beermann <cord@debian.org>  Sat, 25 Feb 2023 17:29:02 +0100

jove (4.17.5.1-1) unstable; urgency=medium

  * New upstream release.
    + jem (Jove Einsteiger Menu) is now part of upstream
    + Documentation has been updated
  * Added -lutil to LDLIBS
  * Updated pt_BR translation by Paulo Henrique de Lima Santana
    (closes: 1028007)
  * Bumped Policy (no changes)

 -- Cord Beermann <cord@debian.org>  Sat, 25 Feb 2023 10:54:51 +0100

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/buildtools.mk
 CPPFLAGS+=$(shell $(PKG_CONFIG) --cflags ncurses)
-LDLIBS+=$(shell $(PKG_CONFIG) --libs ncurses)
+LDLIBS+=$(shell $(PKG_CONFIG) --libs ncurses) -lutil
 
 CC_FOR_BUILD ?= cc
 
@@ -25,14 +25,24 @@
 		JOVEHOME=/usr \
 		JMANDIR=/usr/share/man/man1 \
 		LOCALCC=$(CC_FOR_BUILD) \
-		fdocs all
+		CC=$(CC) \
+		all
 
 override_dh_auto_install:
 	dh_auto_install -- \
+		SYSDEFS="-DLinux" \
+		OPTFLAGS="$(CFLAGS)" \
+		LDLIBS="$(LDLIBS)" \
+		LDFLAGS="$(LDFLAGS)" \
 		JOVEHOME=/usr \
-		JMANDIR=/usr/share/man/man1
-	cp debian/jem.rc debian/jem1.txt debian/jem1.hlp debian/jove/usr/share/jove
+		JMANDIR=/usr/share/man/man1 \
+		LOCALCC=$(CC_FOR_BUILD) \
+		CC=$(CC) \
+		install
 	cp debian/jove.rc debian/jove/etc/jove/jove.rc
+	rm debian/jove/usr/share/jove/jove.man.pdf \
+		debian/jove/usr/share/jove/jove.man.txt \
+		debian/jove/usr/share/jove/jove.qref
 
 override_dh_clean:
 	dh_clean

## jove 4.17.5.3

=== Makefile ===
--- 
+++ 
@@ -31,10 +31,11 @@
 # end with a slash) All others must already exist.
 #
 # Hack for relocatable installs: set JSHAREDIR and JLIBDIR and JBINDIR to relative 
-# paths, and set DESTDIR to an empty directory.
+# paths, set JOVEHOME to an empty directory, and DESTDIR to the install
+# destination with a trailing slash (or to just /, and copy the jove and recover
+# binaries, and the doc subdirectory by hand)
 
 JOVEHOME = /usr/local
-JREL =
 JSHAREDIR = $(JOVEHOME)/share/jove
 DSHAREDIR = $(DESTDIR)$(JSHAREDIR)
 JLIBDIR = $(JOVEHOME)/lib/jove
@@ -46,10 +47,14 @@
 DMANDIR = $(DESTDIR)$(JMANDIR)
 MANEXT = 1
 JTEACHBASE = teach-jove
+TEACHDOC = $(DSHAREDIR)/$(JTEACHBASE)
+JDOCDIR = $(JOVEHOME)/share/doc/jove
+DDOCDIR = $(DESTDIR)$(JDOCDIR)
+REFDOC = $(DDOCDIR)/jove.qref
+EGRC = $(DDOCDIR)/example.rc
 
 # Install permission for SHAREDIR, LIBDIR, BINDIR
 DPERM = 755
-XPERM = 755
 
 # JTMPDIR is where the tmp files get stored, usually /tmp, /var/tmp, or
 # /usr/tmp.  If you wish to be able to recover buffers after a system
@@ -65,7 +70,6 @@
 JTMPDIR = /var/tmp
 JRECDIR = /var/lib/jove/preserve
 DRECDIR = $(DESTDIR)$(JRECDIR)
-
 # Install permission for DRECDIR
 RECPERM = 1777
 
@@ -199,18 +203,20 @@
 ZIPOPTS=-q -k	# common options for both binary and code files
 ZIPTXTOPT=-l -r	# options for recursively adding code files
 TAR=tar
-BACKUPDEV=/dev/rst8	# for tape-backup target!
 
 # These NROFF, TROFF and TROFFPOST settings work with groff.
 # Classic Unix and derivatives used to have ditroff, for which use:
 #	NROFF = nroff
 #	TROFF = troff
-#	TROFFPOST = | /usr/lib/lp/postscript/dpost -
+#	TDEV = ps or TDEV = psc
+#	TROFFPOST = |/usr/lib/lp/postscript/dpost -
+#	or TROFFPOST = |psc
 NROFF = nroff
 TROFF = troff
-TROFFPOST = |grops
-TROFFPDF = |gropdf
-
+TDEV = pdf
+TROFFPOST = |gro$(TDEV)
+
+# installed man pages
 MANUALS = $(JOVEM) $(TEACHJOVEM)
 
 C_SRC = commands.c commands.tab abbrev.c argcount.c ask.c buf.c c.c case.c jctype.c \
@@ -241,15 +247,13 @@
 	doc/jove.rc.3022 doc/keychart.3022 \
 	doc/XTermresource
 
-# XDOCS require no formatting
-XDOCS = doc/teach-jove doc/jove.qref
-
 # formatted docs, we ship these in the distrib to avoid groff dependency
 # and for non-Unix/Linux platforms.  NOTE: These will be removed by clobber.
 # Also note that jove.man.* require the ms macros
 # (tmac.s or s.tmac) which many systems do not install with base groff.
-# Now prefer doc/jove.man.pdf to doc/jove.man.ps (more universal)
-FDOCS = doc/cmds.txt doc/jove.man.txt doc/jove.man.pdf
+# By default, generate & install doc/jove.man.$(TDEV)
+FREFDOCS = doc/jove.man.txt doc/jove.man.$(TDEV)
+FDOCS = doc/cmds.txt $(FREFDOCS)
 
 # files we generate that we also ship in distrib for platforms sans sed
 # NOTE: these will be removed by clobber.
@@ -300,12 +304,3 @@
 
 # portsrv is only needed if IPROCS are implemented using PIPEPROCS
 # (modern systems use PTYPROCS).
-# Making PORTSRVINST null suppresses installing portsrv.
-
-# PORTSRVINST=$(PORTSRV)
-PORTSRVINST=
-
-portsrv$(XEXT):	portsrv.o
-	$(LDCC) $(LDFLAGS) $(CFLAGS) -o portsrv$(XEXT) portsrv.o $(LDLIBS)
-
-recover$(XEXT):	recover.o

=== debian/changelog ===
jove (4.17.5.3-1) unstable; urgency=medium

  * New upstream release.
    + fixed documentation structure (removed workaround)

 -- Cord Beermann <cord@debian.org>  Wed, 22 Mar 2023 20:12:32 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Cord Beermann <cord@debian.org>
 Build-Depends: debhelper-compat (= 13), po-debconf, libncurses-dev, groff, pkgconf
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/jonmacs/jove
 Rules-Requires-Root: no

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/jove-$1\.tar\.gz/ \
  https://github.com/jonmacs/jove/tags .*/v?(\d\S+)\.tar\.gz debian uupdate

## jove 4.17.5.4

=== Makefile ===
--- 
+++ 
@@ -96,6 +96,15 @@
 XINSTALL=install $(INSTALLFLAGS) -m 755
 TINSTALL=install $(INSTALLFLAGS) -m 444
 
+# old mkdir (4BSD and older Unix) did not have -p option, so will
+# need to set MKDIRP=mkdir and create top dirs by hand (or write a script
+# to emulate mkdir -p; 4BSD has basename but not dirname)
+MKDIRP=mkdir -p
+
+# WHICH shoiuld be a command that succeeds if the argument is found in the path
+# WHICH=which # for BSD
+WHICH=type # for sufficiently POSIX shells, not sure if Research Unix has this
+
 # These should all just be right if the above ones are.
 # You will confuse JOVE if you move anything from LIBDIR or SHAREDIR.
 
@@ -289,18 +298,3 @@
 jjove.coff: jjove.rc version.h
 	$(WINDRES) -r jjove.rc -fo jjove.coff
 
-# For 2.xBSD: link jove as a set of overlays.  Not tested recently.
-
-ovjove:	$(OBJECTS)
-	ld $(LDFLAGS) $(OPTFLAGS) -X /lib/crt0.o \
-		-Z $(OVLAY1) \
-		-Z $(OVLAY2) \
-		-Z $(OVLAY3) \
-		-Z $(OVLAY4) \
-		-Z $(OVLAY5) \
-		-Y $(BASESEG) \
-		-o jjove$(XEXT) $(EXTRALIBS) $(TERMCAPLIB) -lc
-	@-size jjove$(XEXT)
-
-# portsrv is only needed if IPROCS are implemented using PIPEPROCS
-# (modern systems use PTYPROCS).

=== xjove/Makefile ===
###########################################################################
# This program is Copyright (C) 1991-1999 by C.H.Lindsey, University of   #
# Manchester.  (X)JOVETOOL is provided to you without charge, and with no #
# warranty.  You may copy, modify, and/or distribute (X)JOVETOOL,         #
# provided that this notice is included in all the files, except insofar  #
# as a more specific copyright notices attaches to the file (x)jovetool.c #
###########################################################################

# Makefile for xjove (XView) and jovetool (SunView)
#
# This makefile may be invoked directly, or by the main JOVE Makefile.
# A number of macros may need to be adjusted for any particular environment.
# If the Makefile is invoked by the main JOVE Makefile, most
# customization will be inherited from that Makefile automatically:
# DEFINES, CC, OPTFLAGS, SYSDEFS, XINSTALL, BINDIR, and INSTALLFLAGS.
# The remaining macros that may need attention are XJLDFLAGS and XJCFLAGS.
# Under Solaris 2, make sure that your OPENWINHOME environment variable
# is set.

# Select optimization level (flags passed to compiling and linking steps).
# On most systems, -g for debugging, -O for optimization.
# On the official Sun ANSI C compiler and the standard System V Release 4
# compiler, adding -Xa -v will increase compiler checking.
OPTFLAGS = -O

# For SunView:
# DEFINES=-DSUNVIEW
DEFINES=

# for Solaris 2.x:
SYSDEFS=-DSYSVR4
# -i: ignore any LD_LIBRARY_PATH setting
# -L<dir>: add <dir> to library search path
# -R<dir[:dir]>: specify library search directories to dynamic linker
XJLDFLAGS= -i -L$$OPENWINHOME/lib -R$$OPENWINHOME/lib

# for Sun0s4.x:
# XJLDFLAGS=-L$$OPENWINHOME/lib
# SYSDEFS=-DSUNOS41

CFLAGS = $(OPTFLAGS) -I.. $(SYSDEFS) $(DEFINES)
XJCFLAGS = -I$$OPENWINHOME/include

BINDIR = /usr/local/bin

# The install commands of BSD and System V differ in unpleasant ways:
# -c: copy (BSD); -c dir: destination directory (SysV)
# -s: strip (BSD); -s: suppress messages (SysV)
# Also, the destination specification is very different.
# The result is that the System V install command must not be used.
# If you know that /bin/install is the BSD program, you can use it.
# "cp" will work reasonably well, but be aware that any links continue
# referencing the old file with new contents.

INSTALLFLAGS = # -g bin -o root

# to install executable files
XINSTALL=cp
#XINSTALL=/usr/ucb/install $(INSTALLFLAGS) -c -m 755 # -s

C_SRC = jovetool.c xjove.c jovewindows.c xjovewindows.c jovemenu.c \
	exts.h jovewindows.h mousemsg.h xjovewindows.h
ICONS = jove.icon jove.cursor copy.cursor cut.cursor paste.cursor
MISC = Makefile README
BACKUPS = $(C_SRC) $(ICONS) $(MISC)

default:		xjove

install:	installxjove

FLIST=.filelist

$(FLIST): $(BACKUPS)
	@ls $(BACKUPS) > $(FLIST)

installxjove:	xjove
		$(XINSTALL) xjove $(BINDIR)/xjove

installjovetool:	jovetool
		$(XINSTALL) jovetool $(BINDIR)/jovetool

jovetool:	jovetool.o jovewindows.o
		$(CC) $(OPTFLAGS) $(LDFLAGS) -o jovetool jovetool.o jovewindows.o -lsuntool -lsunwindow -lpixrect

jovetool.o:	jovetool.c exts.h mousemsg.h $(ICONS)

jovewindows.o:	jovewindows.c jovemenu.c exts.h jovewindows.h ../tune.h

xjove:	xjove.o xjovewindows.o
		$(CC) $(OPTFLAGS) $(LDFLAGS) $(XJLDFLAGS) -o xjove xjove.o xjovewindows.o -lxview -lX11

xjove.o:	xjove.c exts.h mousemsg.h $(ICONS)
		$(CC) $(CFLAGS) $(XJCFLAGS) -c xjove.c

xjovewindows.o:	xjovewindows.c jovemenu.c exts.h xjovewindows.h ../tune.h
		$(CC) $(CFLAGS) $(XJCFLAGS) -c xjovewindows.c

tags:	$(C_SRC)
	ctags -w $(C_SRC)

# override CIFLAGS with something like:
# CIFLAGS = -m'some reason for change' -u4.14.10.n -q

ciall:
	ci $(CIFLAGS) $(BACKUPS)

clean:
		rm -f a.out core *.o jovetool xjove '#'*~ .filelist

clobber:	clean
	rm -f *.orig *.rej

=== debian/changelog ===
jove (4.17.5.4-1) unstable; urgency=medium

  * New upstream release from git.
  * Update sv.po (closes: #1056663)
  * Update pt_BR.po (closes: #1098749)
  * Bump Policy (no changes)

 -- Cord Beermann <cord@debian.org>  Sat, 22 Mar 2025 15:40:44 +0100

=== debian/rules ===
--- 
+++ 
@@ -40,9 +40,9 @@
 		CC=$(CC) \
 		install
 	cp debian/jove.rc debian/jove/etc/jove/jove.rc
-	rm debian/jove/usr/share/jove/jove.man.pdf \
-		debian/jove/usr/share/jove/jove.man.txt \
-		debian/jove/usr/share/jove/jove.qref
+#	rm debian/jove/usr/share/jove/jove.man.pdf \
+#		debian/jove/usr/share/jove/jove.man.txt \
+#		debian/jove/usr/share/jove/jove.qref
 
 override_dh_clean:
 	dh_clean

## jove 4.17.5.5

=== debian/changelog ===
jove (4.17.5.5-2) unstable; urgency=medium

  * Rebuild for gcc-15 (closes: #1096875)
  * README is now installed with upstream-build

 -- Cord Beermann <cord@debian.org>  Thu, 11 Sep 2025 21:41:27 +0200

jove (4.17.5.5-1) unstable; urgency=medium

  * New upstream release.
  * Really update pt_BR.po

 -- Cord Beermann <cord@debian.org>  Sun, 18 May 2025 10:53:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Cord Beermann <cord@debian.org>
 Build-Depends: debhelper-compat (= 13), po-debconf, libncurses-dev, groff, pkgconf
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/jonmacs/jove
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,9 @@
 include /usr/share/dpkg/buildtools.mk
 CPPFLAGS+=$(shell $(PKG_CONFIG) --cflags ncurses)
 LDLIBS+=$(shell $(PKG_CONFIG) --libs ncurses) -lutil
+
+# make it work on gcc-15
+CFLAGS+=--std=c89
 
 CC_FOR_BUILD ?= cc

=== debian/watch ===
Version: 5

# official releases
Template: Github
Owner: jonmacs
Project: jove
Matching-Pattern: .*/v?(\d\S+)\.tar\.gz
Filenamemangle: s/.+\/v?(\d\S+)\.tar\.gz/jove-$1\.tar\.gz/
Update-Script: uupdate

# inoffical updates
#Source: https://github.com/jonmacs/jove.git
#Matching-Pattern: HEAD
#Mode: git
#Pgpmode: none
#Pretty: describe
## Filename-Mangle: s/^(@PACKAGE@-)v/$1/
#Repack: yes
#Update-Script: uupdate

#version=4

#opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/jove-$1\.tar\.gz/ \
#  https://github.com/jonmacs/jove/tags .*/v?(\d\S+)\.tar\.gz debian uupdate
